class LSTM(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", "weight_ih_l0_reverse", "weight_hh_l0_reverse", "bias_ih_l0_reverse", "bias_hh_l0_reverse", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  weight_ih_l0_reverse : Tensor
  weight_hh_l0_reverse : Tensor
  bias_ih_l0_reverse : Tensor
  bias_hh_l0_reverse : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  mode : Final[str] = "LSTM"
  dropout : Final[float] = 0.
  proj_size : Final[int] = 0
  input_size : Final[int] = 512
  num_layers : Final[int] = 1
  batch_first : Final[bool] = True
  bidirectional : Final[bool] = True
  hidden_size : Final[int] = 256
  bias : Final[bool] = True
  def forward__0(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    max_batch_size = torch.size(input, 0)
    if torch.__is__(hx, None):
      _0 = ops.prim.dtype(input)
      _1 = ops.prim.device(input)
      h_zeros = torch.zeros([2, max_batch_size, 256], dtype=_0, layout=None, device=_1)
      _2 = ops.prim.dtype(input)
      _3 = ops.prim.device(input)
      c_zeros = torch.zeros([2, max_batch_size, 256], dtype=_2, layout=None, device=_3)
      hx0 = (h_zeros, c_zeros)
    else:
      hx1 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx2 = (self).permute_hidden(hx1, None, )
      hx0 = hx2
    _4 = (self).check_forward_args(input, hx0, None, )
    _flat_weights = self._flat_weights
    training = self.training
    _5, _6, = hx0
    _7, _8, _9 = torch.lstm(input, [_5, _6], _flat_weights, True, 1, 0., training, True, True)
    hidden = (_8, _9)
    _10 = (self).permute_hidden(hidden, None, )
    return (_7, _10)
  def forward__1(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tuple[Tensor, Tensor]]:
    input0, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    max_batch_size0 = int(max_batch_size)
    if torch.__is__(hx, None):
      _11 = ops.prim.dtype(input0)
      _12 = ops.prim.device(input0)
      h_zeros = torch.zeros([2, max_batch_size0, 256], dtype=_11, layout=None, device=_12)
      _13 = ops.prim.dtype(input0)
      _14 = ops.prim.device(input0)
      c_zeros = torch.zeros([2, max_batch_size0, 256], dtype=_13, layout=None, device=_14)
      hx3 = (h_zeros, c_zeros)
    else:
      hx4 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx5 = (self).permute_hidden(hx4, sorted_indices, )
      hx3 = hx5
    _15 = (self).check_forward_args(input0, hx3, batch_sizes, )
    _flat_weights = self._flat_weights
    training = self.training
    _16, _17, = hx3
    _18, _19, _20 = torch.lstm(input0, batch_sizes, [_16, _17], _flat_weights, True, 1, 0., training, True)
    hidden = (_19, _20)
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(_18, batch_sizes, sorted_indices, unsorted_indices)
    _21 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output_packed, _21)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tuple[Tensor, Tensor],
    permutation: Optional[Tensor]) -> Tuple[Tensor, Tensor]:
    _22 = __torch__.torch.nn.modules.rnn.apply_permutation
    if torch.__is__(permutation, None):
      _23 = hx
    else:
      permutation0 = unchecked_cast(Tensor, permutation)
      _24 = (_22((hx)[0], permutation0, 1, ), _22((hx)[1], permutation0, 1, ))
      _23 = _24
    return _23
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hidden: Tuple[Tensor, Tensor],
    batch_sizes: Optional[Tensor]) -> NoneType:
    _25 = "Expected hidden[0] size {}, got {}"
    _26 = "Expected hidden[1] size {}, got {}"
    _27 = (self).check_input(input, batch_sizes, )
    _28 = (hidden)[0]
    _29 = (self).get_expected_hidden_size(input, batch_sizes, )
    _30 = (self).check_hidden_size(_28, _29, _25, )
    _31 = (hidden)[1]
    _32 = (self).get_expected_cell_size(input, batch_sizes, )
    _33 = (self).check_hidden_size(_31, _32, _26, )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _34 = "input must have {} dimensions, got {}"
    _35 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _36 = torch.ne(torch.dim(input), expected_input_dim)
    if _36:
      _37 = torch.format(_34, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_37)
    else:
      pass
    _38 = torch.ne(512, torch.size(input, -1))
    if _38:
      _39 = torch.format(_35, 512, torch.size(input, -1))
      ops.prim.RaiseException(_39)
    else:
      pass
    return None
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _40 = torch.size(hx)
    _41, _42, _43, = expected_hidden_size
    if torch.ne(_40, [_41, _42, _43]):
      _44 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_44)
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes0 = unchecked_cast(Tensor, batch_sizes)
      mini_batch0 = int(torch.select(batch_sizes0, 0, 0))
      mini_batch = mini_batch0
    else:
      mini_batch = torch.size(input, 0)
    return (2, mini_batch, 256)
  def get_expected_cell_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes1 = unchecked_cast(Tensor, batch_sizes)
      mini_batch1 = int(torch.select(batch_sizes1, 0, 0))
      mini_batch = mini_batch1
    else:
      mini_batch = torch.size(input, 0)
    return (2, mini_batch, 256)
def apply_permutation(tensor: Tensor,
    permutation: Tensor,
    dim: int=1) -> Tensor:
  _45 = torch.index_select(tensor, dim, permutation)
  return _45
